/**
 *	@file	MainFrame_Dfg.cpp
 *	@brief	CMainFrame dfg[hZ[u֌W.
 *	@note
 *		+++ MainFrame.cpp dfg[hZ[u֌W𕪗.
 */

#include "stdafx.h"
#include "MainFrame.h"
#include "XmlFile.h"


#if defined USE_ATLDBGMEM
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


struct _Function_Enum_ChildInfomation {
	CMainFrame*					m_pMainFrame;
	HWND						m_hWndActive;
	std::list<SDfgSaveInfo>&	m_rSaveInfoList;
	int 						m_nIndex;
	bool						m_bSaveFB;
	int 						m_nActiveIndex;

	// RXgN^
	_Function_Enum_ChildInfomation(
			CMainFrame*					pMainFrame,
			HWND						hWndActive,
			std::list<SDfgSaveInfo>&	rSaveInfoList,
			int 						nIndex		= 0,
			bool						bSaveFB 	= FALSE)
		:	m_pMainFrame(pMainFrame)
		,	m_hWndActive(hWndActive)
		,	m_rSaveInfoList(rSaveInfoList)
		,	m_nIndex(nIndex)
		,	m_bSaveFB(bSaveFB)
		,	m_nActiveIndex(-1)
	{
	}

	void operator ()(HWND hWnd)
	{
		if (hWnd == m_hWndActive)
			m_nActiveIndex = m_nIndex;

		//3ȏ̈𑗂̂ʓ|Ȃ̂ŒCChildFrame𑀍
		CChildFrame *pChild = m_pMainFrame->GetChildFrame(hWnd);
		if (!pChild) {
			ErrorLogPrintf(_T("dfg̃Z[uł̏擾Ɏs\n"));
			return;
		}

		try {	//+++ ÔߗO`FbN.
			m_rSaveInfoList.push_back( SDfgSaveInfo() );
			pChild->view().m_ViewOption.GetDfgSaveInfo( m_rSaveInfoList.back(), m_bSaveFB );
		} catch(...) {
			ErrorLogPrintf(_T("dfg̃Z[uɗO\n"));
		}
		++m_nIndex;
	}
};


void	CMainFrame::SaveAllTab()
{
	/* ׂẴ^ȕ擾 */
	std::list<SDfgSaveInfo>	SaveInfoList;
	_Function_Enum_ChildInfomation	f(this, MDIGetActive(), SaveInfoList, 0, CMainOption::s_bTravelLogGroup);
	m_MDITab.ForEachWindow( f );

	CString	TabList = Misc::GetExeDirectory() + _T("TabList.xml");

	if (::PathFileExists(TabList)) {
		CString strBakFile = Misc::GetFileNameNoExt(TabList) + _T(".bak.xml");
		::MoveFileEx(TabList, strBakFile, MOVEFILE_REPLACE_EXISTING);
	}

	try {
		CXmlFileWrite	xmlWrite(TabList);

		// <TabList>
		xmlWrite.WriteStartElement(L"TabList");
		CString strActiveIndex;
		strActiveIndex.Format(_T("%d"), f.m_nActiveIndex);
		xmlWrite.WriteAttributeString(L"ActiveIndex", strActiveIndex);

		std::list<SDfgSaveInfo>::iterator it = SaveInfoList.begin();
		for (; it != SaveInfoList.end(); ++it) {
			xmlWrite.WriteStartElement(L"Tab");
			xmlWrite.WriteAttributeString(L"title"		, it->m_title);
			xmlWrite.WriteAttributeString(L"url"		, it->m_location_URL);
			CString strDLCtrlFlags;
			strDLCtrlFlags.Format(_T("%d"), it->m_DL_Control_Flags);
			xmlWrite.WriteAttributeString(L"DLCtrlFlags", strDLCtrlFlags);
			CString	strExStyle;
			strExStyle.Format(_T("%d"), it->m_dwExStyle);
			xmlWrite.WriteAttributeString(L"ExStyle"	, strExStyle);
			CString strAutoRefreshStyle;
			strAutoRefreshStyle.Format(_T("%d"), it->m_dwAutoRefreshStyle);
			xmlWrite.WriteAttributeString(L"AutoRefreshStyle", strAutoRefreshStyle);

			xmlWrite.WriteStartElement(L"TravelLog");
			xmlWrite.WriteStartElement(L"Back");
			std::vector<std::pair<CString, CString> >::iterator itback = it->m_listBack.begin();
			for (; itback != it->m_listBack.end(); ++itback) {
				xmlWrite.WriteStartElement(L"item");
				xmlWrite.WriteAttributeString(L"title", itback->first);
				xmlWrite.WriteAttributeString(L"url"  , itback->second);
				xmlWrite.WriteFullEndElement();	// </item>
			}
			xmlWrite.WriteFullEndElement();	// </Back>

			xmlWrite.WriteStartElement(L"Fore");
			std::vector<std::pair<CString, CString> >::iterator itfore = it->m_listFore.begin();
			for (; itfore != it->m_listFore.end();++itfore) {
				xmlWrite.WriteStartElement(L"item");
				xmlWrite.WriteAttributeString(L"title", itfore->first);
				xmlWrite.WriteAttributeString(L"url"  , itfore->second);
				xmlWrite.WriteFullEndElement();	// </item>
			}
			xmlWrite.WriteFullEndElement();	// </Fore>
			xmlWrite.WriteFullEndElement();	// </TravelLog>

			xmlWrite.WriteFullEndElement();	// </Tab>
		}
	}
	catch (LPCTSTR strError) {
		MessageBox(strError);
	}
	catch (...) {
		MessageBox(_T("SaveAllTabListɎs"));
	}
}



void	CMainFrame::RestoreAllTab(LPCTSTR strFilePath, bool bClose)
{
	/* default.dfg΂g */
	CString	strFile = CStartUpOption::GetDefaultDFGFilePath();
	if (::PathFileExists(strFile)) {
		if ( MtlIsExt( strFile, _T(".dfg") ) ) {
			if ( !(CMainOption::s_dwMainExtendedStyle & MAIN_EX_NOCLOSEDFG) ) {
				_LoadGroupOption(strFile, true);
			} else {
				_LoadGroupOption(strFile, false);
			}
			CString strBakFile = Misc::GetFileNameNoExt(strFile) + _T(".bak.dfg");
			::MoveFileEx(strFile, strBakFile, MOVEFILE_REPLACE_EXISTING);
			return;
		}
	}

	int	nActiveIndex = 0;
	std::vector<SDfgSaveInfo>	vecSaveInfo;
	SDfgSaveInfo				Info;

	CString	TabList;
	if (strFilePath == NULL) {
		TabList = Misc::GetExeDirectory() + _T("TabList.xml");
	} else {
		TabList = strFilePath;
	}

	try {
		CXmlFileRead	xmlRead(TabList);
		CString 		Element;
		XmlNodeType 	nodeType;
		while (xmlRead.Read(&nodeType) == S_OK) {
			switch (nodeType) {
			case XmlNodeType_Element:
				{
					Element = xmlRead.GetLocalName();	// vf擾
					if (Element == _T("TabList")) {
						if (xmlRead.MoveToFirstAttribute()) {
							if (xmlRead.GetLocalName() == _T("ActiveIndex")) {
								nActiveIndex = _ttoi(xmlRead.GetValue());
							}
						}
					}else if (Element == _T("Tab")) {
						if (xmlRead.MoveToFirstAttribute()) {
							do {
								CString strName = xmlRead.GetLocalName();
								if (strName == _T("title")) {
									Info.m_title = xmlRead.GetValue();
								} else if (strName == _T("url")) {
									Info.m_location_URL = xmlRead.GetValue();
								} else if (strName == _T("DLCtrlFlags")) {
									Info.m_DL_Control_Flags = _ttoi(xmlRead.GetValue());
								} else if (strName == _T("ExStyle")) {
									Info.m_dwExStyle = _ttoi(xmlRead.GetValue());
								} else if (strName == _T("AutoRefreshStyle")) {
									Info.m_dwAutoRefreshStyle = _ttoi(xmlRead.GetValue());
								}
							} while (xmlRead.MoveToNextAttribute());
						}
					} else if (Element == _T("Back")) {
						CString	strItem;
						while (xmlRead.GetInternalElement(_T("Back"), strItem)) {
							if (strItem == _T("item")) {
								CString title;
								CString url;
								if (xmlRead.MoveToFirstAttribute()) {
									title = xmlRead.GetValue();
									if (xmlRead.MoveToNextAttribute()) {
										url = xmlRead.GetValue();
										Info.m_listBack.push_back(std::make_pair(title, url));
									}
								}
							}
						}

					} else if (Element == _T("Fore")) {
						CString	strItem;
						while (xmlRead.GetInternalElement(_T("Fore"), strItem)) {
							if (strItem == _T("item")) {
								CString title;
								CString url;
								if (xmlRead.MoveToFirstAttribute()) {
									title = xmlRead.GetValue();
									if (xmlRead.MoveToNextAttribute()) {
										url = xmlRead.GetValue();
										Info.m_listFore.push_back(std::make_pair(title, url));
									}
								}
							}
						}
					}
					break;
				}
			case XmlNodeType_EndElement:
				{
					if (xmlRead.GetLocalName() == _T("Tab")) {
						// </Tab>ɂ̂
						vecSaveInfo.push_back(Info);

						Info.m_listBack.clear();
						Info.m_listFore.clear();
					}
					break;
				}
			}
		}

		/////////////////////////////////////////////////////////////
		// ^u𕜌

		CLockRedrawMDIClient	 lock(m_hWndMDIClient);
		CMDITabCtrl::CLockRedraw lock2(m_MDITab);
		CWaitCursor 			 cur;

		if (bClose) {
			MtlCloseAllMDIChildren(m_hWndMDIClient);
		}

		DWORD			dwCount 	= 0;
		bool			bActiveChildExistAlready = (MDIGetActive() != NULL);

		m_MDITab.m_bInsertHere		= true;
		m_MDITab.m_nInsertIndex 	= m_MDITab.GetItemCount();

		CChildFrame *	pChildActive = NULL;

		/* ^uɒǉĂ */
		for (UINT i = 0; i < vecSaveInfo.size(); ++i) {
			CChildFrame *pChild = CChildFrame::NewWindow(m_hWndMDIClient, m_MDITab, m_AddressBar);
			if (pChild == NULL)
				continue;

			++m_MDITab.m_nInsertIndex;

			// if tab mode, no need to load window placement.
			//pChild->view().m_ViewOption.GetProfile(strFileName, dw, !CMainOption::s_bTabMode);

			// DLCtrlݒ
			pChild->view().PutDLControlFlags(vecSaveInfo[i].m_DL_Control_Flags);
			// Navigate
			pChild->Navigate2(vecSaveInfo[i].m_location_URL);
			//
			pChild->view().m_ViewOption.m_dwExStyle	= vecSaveInfo[i].m_dwExStyle;

			pChild->view().m_ViewOption.m_dwAutoRefreshStyle = vecSaveInfo[i].m_dwAutoRefreshStyle;
			pChild->view().m_ViewOption.Init();	// ^C}[Jn

			// activate now!
			pChild->ActivateFrame(MDIGetActive() != NULL ? SW_SHOWNOACTIVATE : -1);

			/* ߂Eiނ̍ڂݒ肷 */
			if (CMainOption::s_bTravelLogGroup) {
				pChild->SetArrayHist(vecSaveInfo[i].m_listFore, vecSaveInfo[i].m_listBack);
			}

			if (i == nActiveIndex) {
				pChildActive = pChild;
			}
		}

		m_MDITab.m_bInsertHere	= false;
		m_MDITab.m_nInsertIndex = -1;

		if (pChildActive == NULL)
			return;

		if (bActiveChildExistAlready == false) {						// there was no active window
			MDIActivate(pChildActive->m_hWnd);
			if (CMainOption::s_bTabMode) {	// in tab mode
				MDIMaximize(pChildActive->m_hWnd);
			}
		} else {												// already an active window exists
			if ( !(CMainOption::s_dwMainExtendedStyle & MAIN_EX_NOACTIVATE) )
				MDIActivate(pChildActive->m_hWnd);
		}

	}
	catch (LPCTSTR strError) {
		MessageBox(strError);
	}
	catch (...) {
		MessageBox(_T("RestoreAllTabɎs"));
	}
}

//private:
//+++ O[vIvṼZ[u.
//+++ - t@C̔r₷邽߁AWƁAinit@Cւ݂̏̃^C~O𕪗.
//+++ - r䎩̂CIniFileɔC.
//+++ - ́Aq̏W̎擾܂ߕʃXbhŏĂAǂ̕ӂ܂
//+++	낢šɂȂĂ͗l.i"iށE߂"TravelLogɁAieR|[lg(dll)
//+++	ŃnOĂj

// ^uP̏擾
struct CMainFrame::_Function_EnumChildSaveOption {
	CMainFrame *				m_pMainFrame;
	HWND						m_hWndActive;
	std::list<SDfgSaveInfo>&	m_rDfgSaveInfoList;
	int 						m_nIndex;
	bool						m_bSaveFB;
	int 						m_nActiveIndex;

	_Function_EnumChildSaveOption(
			CMainFrame *				pMainFrame,
			HWND						hWndActive,
			std::list<SDfgSaveInfo>&	rDrfSaveInfoList,
			int 						nIndex		= 0,
			bool						bSaveFB 	= FALSE)
		:	m_pMainFrame(pMainFrame)
		,	m_hWndActive(hWndActive)
		,	m_rDfgSaveInfoList(rDrfSaveInfoList)
		,	m_nIndex(nIndex)
		,	m_bSaveFB(bSaveFB)
		,	m_nActiveIndex(-1)
	{
	}

	void operator ()(HWND hWnd)
	{
		if (hWnd == m_hWndActive)
			m_nActiveIndex = m_nIndex;

		CString 	 strSection;
		strSection.Format(_T("Window%d"), m_nIndex);

		//3ȏ̈𑗂̂ʓ|Ȃ̂ŒCChildFrame𑀍
		CChildFrame *pChild = m_pMainFrame->GetChildFrame(hWnd);
		if (!pChild) {
			ErrorLogPrintf(_T("dfg̃Z[uł̏擾%s(qEBhE%#x)̎擾Ɏs\n"), LPCTSTR(strSection), hWnd);
			return;
		}

		try {	//+++ ÔߗO`FbN.
			m_rDfgSaveInfoList.push_back( SDfgSaveInfo() );
			m_rDfgSaveInfoList.back().m_section = strSection;
			pChild->view().m_ViewOption.GetDfgSaveInfo( m_rDfgSaveInfoList.back(), m_bSaveFB );
		} catch(...) {
			ErrorLogPrintf(_T("dfg̃Z[u%s(qEBhE%#x)̃Z[uɗO\n"), LPCTSTR(strSection), hWnd);
		}
		++m_nIndex;
	}
};


CMainFrame::CSaveGroupOptionToFile::CSaveGroupOptionToFile()
	:	m_bOldMaximized(0)
	,	m_bSaveTravelLog(0)
	,	m_nIndex(0)
	,	m_nActiveIndex(0)
	,	m_phThread(0)
	,	m_strFileName()
	,	m_dfgSaveInfoList()
{
}

CMainFrame::CSaveGroupOptionToFile::~CSaveGroupOptionToFile() {
	if (m_phThread && *m_phThread) {	//+++ XbhĂƁAm_dfgSaveInfoList̃fXgNg܂...
		DWORD dwResult = ::WaitForSingleObject(*m_phThread, DONUT_BACKUP_THREADWAIT);
		//x CloseHandle(*m_phThread);
	}
}


void CMainFrame::CSaveGroupOptionToFile::Run(CMainFrame* pMainWnd, const CString &strFileName, bool bDelay) // modified by minit
{
	if (pMainWnd == 0)
		return;
	if (pMainWnd->m_hGroupThread) {
		DWORD dwReturnCode = 0;
		::GetExitCodeThread(pMainWnd->m_hGroupThread, &dwReturnCode);
		if (dwReturnCode == STILL_ACTIVE) {
			ErrorLogPrintf(_T("defalut.dfg̑ÕZ[uɗ\zȏɎԂĂ悤Ȃ̂ō͌.\n"));
			return;
		}
		//+++ UI.
		::CloseHandle(pMainWnd->m_hGroupThread);
		pMainWnd->m_hGroupThread = NULL;
	}

	m_phThread			= &pMainWnd->m_hGroupThread;
	m_strFileName		= strFileName;
	m_bOldMaximized		= FALSE;
	m_bSaveTravelLog	= CMainOption::s_bTravelLogGroup != 0/*? TRUE : FALSE*/;
	m_dfgSaveInfoList.clear();
	HWND	hWndActive	= pMainWnd->MDIGetActive(&m_bOldMaximized);

	//+++ ܂͏擾s.
	_Function_EnumChildSaveOption	f(pMainWnd, hWndActive, m_dfgSaveInfoList, 0, m_bSaveTravelLog);

	try {	//+++ ӖȂȂǔÔߗO`FbN.
		// f=
		pMainWnd->m_MDITab.ForEachWindow( f );		// MtlForEachMDIChild(m_hWndMDIClient, f);
	} catch (...) {
		ErrorLogPrintf(_T("O[vIvVZ[uɗO\n"));
	}

	m_nIndex		= f.m_nIndex;
	m_nActiveIndex	= f.m_nActiveIndex;

	if (bDelay == 0) {	//+++ init@Cւ݂̏𓯊łꍇ.
		WriteIniFile();
	} else {			//+++ init@Cւ݂̏񓯊ɂꍇ.
		UINT	dwThreadID = 0;
		pMainWnd->m_hGroupThread = (HANDLE) _beginthreadex(NULL, 0, CSaveGroupOptionToFile::WriteIniFile_Thread, (LPVOID) this, 0, &dwThreadID);
	}
}

//private:
UINT __stdcall CMainFrame::CSaveGroupOptionToFile::WriteIniFile_Thread(void* pParam)
{
	CSaveGroupOptionToFile* pThis = (CSaveGroupOptionToFile*)pParam;
	pThis->WriteIniFile();
	_endthreadex(0);
	return 0;
}


void CMainFrame::CSaveGroupOptionToFile::WriteIniFile()
{
  #if 1	//+++ jP̃ACfAŁAobNAbvt@C .dfg.bak łȂ .bak.dfg ɂĂ݂.
	CString		strFileName	= m_strFileName;
	CString 	strBakName	= Misc::GetFileNameNoExt(strFileName) + ".bak.dfg";
	if (::GetFileAttributes(strBakName) != 0xFFFFFFFF)
		::DeleteFile(strBakName);					// ÂobNAbvt@C폜.
	if (::GetFileAttributes(strFileName) != 0xFFFFFFFF)
		::MoveFile(strFileName, strBakName);		// ̃t@CobNAbvt@Cɂ.
  #endif

	//+++ dfgt@CɃZ[u
	CIniFileO	pr( m_strFileName, _T("Window") );
	//pr.RemoveFileToBak();			// strFileName 폜(.bak)

	//+++ ŜɊւݒۑ
	pr.ChangeSectionName( _T("Header") );
	pr.SetValue( m_nIndex				, _T("count")	  );
	pr.SetValue( m_nActiveIndex 		, _T("active")	  );	// active index
	pr.SetValue( (m_bOldMaximized != 0)	, _T("maximized") );

	//+++ Ƃ̐ݒۑ
	for (std::list<SDfgSaveInfo>::iterator it = m_dfgSaveInfoList.begin();
			it != m_dfgSaveInfoList.end();
			++it)
	{
		it->WriteProfile(pr, m_bSaveTravelLog);
	}
}



// ===========================================================================

///+++
void CMainFrame::_SaveGroupOption(const CString &strFileName, bool bDelay /*=false*/)
{
	m_saveGroupOptionToFile.Run(this, strFileName, bDelay);

  #if 0	//+++ v1.48c ō폜. px̎Z[uݒ肳ĂƁAɂĂ̓ptH[}X傫݂Ȃ̂off.
	//x RtlSetMinProcWorkingSetSize();				//+++ ( ̗\̈ꎞIɍŏBEBhEŏꍇƓ ) ... ЂƂƂ܂낵Ȃ...
  #endif
}



void CMainFrame::_LoadGroupOption(const CString &strFileName, bool bClose)
{
	//dmfTRACE( _T("CMainFrame::_LoadGroupOption\n") );

	CLockRedrawMDIClient	 lock(m_hWndMDIClient);
	CMDITabCtrl::CLockRedraw lock2(m_MDITab);
	CWaitCursor 			 cur;

	if (bClose)
		MtlCloseAllMDIChildren(m_hWndMDIClient);

	DWORD			dwCount 	= 0;
  #if INISECTION_USE_MUTEX != 1
	CIniFileI		pr( strFileName, _T("Header") );
	if (pr.QueryValue( dwCount, _T("count") ) != ERROR_SUCCESS)
		return;
	DWORD			dwActive	= pr.GetValue( _T("active")   , 0 );
	DWORD			dwMaximized = pr.GetValue( _T("maximized"), 0 );
	pr.Close();
  #else
	CIniFileI		pr( strFileName, _T("Header") );
	if (pr.QueryValue( dwCount, _T("count") ) != ERROR_SUCCESS)
		return;
	DWORD			dwActive	= pr.GetValue( _T("active")   , 0 );
	DWORD			dwMaximized = pr.GetValue( _T("maximized"), 0 );
  #endif

	bool			bActiveChildExistAlready = (MDIGetActive() != NULL);

	m_MDITab.m_bInsertHere		= true;
	m_MDITab.m_nInsertIndex 	= m_MDITab.GetItemCount();

	CChildFrame *	pChildActive = NULL;
	for (DWORD dw = 0; dw < dwCount; ++dw) {
		CChildFrame *pChild = CChildFrame::NewWindow(m_hWndMDIClient, m_MDITab, m_AddressBar);
		// if no active child, as there is no client edge in MDI client window,
		// so GetClientRect is different a little and a resizing will occur when switching.
		// That is, only the first child window is activated.
		if (pChild == NULL)
			continue;

		++m_MDITab.m_nInsertIndex;

		// activate now!
		pChild->ActivateFrame(MDIGetActive() != NULL ? SW_SHOWNOACTIVATE : -1);

		// if tab mode, no need to load window placement.
		pChild->view().m_ViewOption.GetProfile(strFileName, dw, !CMainOption::s_bTabMode);

		// ߂Eiނ̍ڂݒ肷
		if (CMainOption::s_bTravelLogGroup) {
			CString 	strSection;
			strSection.Format(_T("Window%d"), dw);
			_Load_OptionalData(pChild, strFileName, strSection);
		}

		if (dw == dwActive)
			pChildActive = pChild;
	}

	m_MDITab.m_bInsertHere	= false;
	m_MDITab.m_nInsertIndex = -1;

	if (pChildActive == NULL)
		return;

	if (!bActiveChildExistAlready) {						// there was no active window
		MDIActivate(pChildActive->m_hWnd);
		if (CMainOption::s_bTabMode || dwMaximized == 1) {	// in tab mode
			MDIMaximize(pChildActive->m_hWnd);
		}
	} else {												// already an active window exists
		if ( !(CMainOption::s_dwMainExtendedStyle & MAIN_EX_NOACTIVATE) )
			MDIActivate(pChildActive->m_hWnd);
	}
}



// ===========================================================================

void CMainFrame::OnBackUpOptionChanged(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/)
{
	if (m_nBackUpTimerID != 0) {
		KillTimer(m_nBackUpTimerID);
		m_nBackUpTimerID = 0;
	}

	if (CMainOption::s_dwMainExtendedStyle & MAIN_EX_BACKUP)
		m_nBackUpTimerID = SetTimer(1, 1000 * 60 * CMainOption::s_dwBackUpTime);
}


//private:
void CMainFrame::OnFavoriteGroupSave(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/)
{
	if (MDIGetActive() == NULL)
		return;

	TCHAR		szOldPath[MAX_PATH];	// save current directory
	szOldPath[0]	= 0;	//+++
	::GetCurrentDirectory(MAX_PATH, szOldPath);

	CString dir = DonutGetFavoriteGroupFolder();
	::SetCurrentDirectory( LPCTSTR(dir) );

	const TCHAR szFilter[] = _T("Donut Favorite Groupt@C(*.dfg)\0*.dfg\0\0");
	CFileDialog fileDlg(FALSE, _T("dfg"), NULL, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, szFilter);
	fileDlg.m_ofn.lpstrInitialDir = dir;
	fileDlg.m_ofn.lpstrTitle	  = _T("CɓO[v̕ۑ");

	if (fileDlg.DoModal() == IDOK) {
		_SaveGroupOption(fileDlg.m_szFileName);
		::SendMessage(m_hWnd, WM_REFRESH_EXPBAR, 1, 0);
	}

	// restore current directory
	::SetCurrentDirectory(szOldPath);
}


void CMainFrame::OnFavoriteGroupAdd(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/)
{
	::SendMessage(MDIGetActive(), WM_COMMAND, (WPARAM) ID_FAVORITE_GROUP_ADD, 0);
}


void CMainFrame::OnFavoriteGroupOrganize(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/)
{
	::ShellExecute(m_hWnd, NULL, DonutGetFavoriteGroupFolder(), NULL, NULL, SW_SHOWNORMAL);
}



#if 1 //+++ WS_CAPTIONtXN[AƂÔĂ̂ŁAMtl̊O֐̂ֈړ
template <class _Profile>
static void /*Mtl*/WriteProfileStatusBarState( _Profile &__profile, HWND hWndStatusBar, const CString &strPrefix = _T("statusbar.") )
{
	ATLASSERT( ::IsWindow(hWndStatusBar) );

	// eAޔ͕ۑȂ
	HWND hWndParent = ::GetParent(hWndStatusBar);
	if (hWndParent) {
		if (::IsWindowVisible(hWndParent) == FALSE)
			return;
		//if (IsFullScreen())
		if (g_pMainWnd->IsFullScreen())		//+++
			return;
	}
	LONG lRet		= __profile.SetValue( ::IsWindowVisible(hWndStatusBar) != 0, strPrefix + _T("Visible") );
	ATLASSERT(lRet == ERROR_SUCCESS);
}
#endif


void CMainFrame::_WriteProfile()
{
	// save frame and status bar
	CIniFileO	pr( g_szIniFileName, _T("Main") );
	MtlWriteProfileMainFrameState(pr, m_hWnd);
	/*Mtl*/WriteProfileStatusBarState(pr, m_hWndStatusBar);

	// save MDI tab
	pr.ChangeSectionName(_T("MDITab"));
	MtlWriteProfileMDITab(pr, m_MDITab);

	// save rebar
	pr.ChangeSectionName(_T("ReBar"));
	MtlWriteProfileReBarBandsState(pr, m_hWndToolBar);
	pr.Close();

  #if 0 //+++ OnClosêςȂɍs悤ɕύX... //ς肱
	// save group options
	_SaveGroupOption( CStartUpOption::GetDefaultDFGFilePath() );
  #endif
}

